// Dll.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "..\VimasCodec4800.h"

void Encode(const char* strFileInput, const char* strFileCompress);
void Decode(const char* strFileInput, const char* strFileSynt);

#define   FILE_INPUT "1073_a.pcm"
#define   FILE_COMPRESS "comp48.prm"
#define   FILE_SYNT "synta.pcm"

int main(int argc, char* argv[])
{
	Encode(FILE_INPUT, FILE_COMPRESS);
	Decode(FILE_COMPRESS, FILE_SYNT);
	return 0;
}

void Encode(const char* strFileInput, const char* strFileCompress)
{
    FILE  *fin,*fcomp; 
    long i;
    long  NF;
//	short vad;
    short Input[Frame]; 
	unsigned char CodedFrame[CodedFrameSize];

	if( (fin=fopen(strFileInput,"rb"))==NULL)
	{
		printf("Can not open input file\n");
	    return;
	}

  // Calculate the number of frames in the file
    fseek(fin, 0L, SEEK_END);
    NF = ftell(fin);
    rewind(fin);
    NF /= sizeof(short)*Frame ;
    printf("Frames in file  %d \n", NF);
    

    fcomp=fopen(strFileCompress,"wb");
    
   	HANDLE hCodec = Init();

    // Do compression 

             for( i=0; i<NF; i++ )
			 {

		       fread (Input, sizeof(short), Frame, fin);

		       FrameEncoder(hCodec, Input, CodedFrame, 50 ) ; 

               fwrite(CodedFrame, sizeof(char), CodedFrameSize, fcomp);

               printf("Processed frames  %d \r", i);
    }

  fclose(fcomp); 
  fclose(fin);

  DeInit(hCodec);
}

void Decode(const char* strFileInput, const char* strFileSynt)
{
    FILE  *fin, *fout;      
    long i;
    long  NF;
	short Output[Frame]; 

	unsigned char FrameSynt[CodedFrameSize];

   	HANDLE hCodec = Init();

	if( (fin=fopen(strFileInput,"rb"))==NULL)
	{
		printf("Can not open input file\n");
		return;
	}

  // Calculate the number of frames in the file
    fseek(fin, 0L, SEEK_END);
    NF = ftell(fin);
    rewind(fin);
    NF /= CodedFrameSize ;
    printf("Frames in file  %d \n", NF);
    


	fout=fopen(strFileSynt,"wb");
    
 
  // Do decompression

     for( i=0; i<NF; i++ )
	 {

       fread (FrameSynt, sizeof(char), CodedFrameSize, fin);

	   FrameDecoder(hCodec, FrameSynt, Output,  0 ) ;

	   fwrite(Output, sizeof(short),Frame,fout);

       printf("Processed frames  %d \r", i);
     }

     fclose(fin);
     fclose(fout); 

	DeInit(hCodec);
}

